//#################################################################################################//
//#                                                                                               #// 
//#  **** Schneider Engineering, Bad Vilbel ***                                                   #//
//#  **** Inh.  Dipl.-Ing. Peter Schneider  ***                                                   #//
//#                                                                                               #//
//#  Filename :  odemetrie.c                                                                      #//
//#  Project  :  Roboter                                                                          #//
//#                                                                                               #//
//#                                                                                               #//    
//#  Odemetrie mit BUG2 Pathfindig Algorithmus ein moeglicher Implementierungsvorschlag           #// 
//#  Quelle des Algorithmus www.wikipedia.de                                                      #//
//#                                                                                               #//
//#  (c) Peter Schneider (Schneider Engineering software / hardware development)                  #//
//#  www.ps-robotics.com                                                                          #//
//#                                                                                               #//
//#  Version:                                                                                     #//         
//#  1.03       14 August 2011 11:55       Original release                                       #//
//#                                                                                               #//
//#  This program is free software; you can redistribute it and/or modify                         #//
//#  it under the terms of the GNU General Public License as published by                         #//
//#  the Free Software Foundation; either version 2 of the License, or                            #//
//#  (at your option) any later version.                                                          #//
//#                                                                                               #//		
//#  This program is distributed in the hope that it will be useful,                              #//
//#  but WITHOUT ANY WARRANTY; without even the implied warranty of                               #//	
//#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                #//	
//#  GNU General Public License for more details.                                                 #//
//#                                                                                               #//
//#  You should have received a copy of the GNU General Public License                            #//
//#  along with this program; if not, write to peter.schneider@ps-robotics.de                     #//
//#                                                                                               #//
//#################################################################################################//
//
//
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include <stdlib.h>
#include <windows.h>
#include <string.h>
#include <commctrl.h>
#include <ctype.h>

// Einbinder des HeaderFiles "bug2Libaray.h"
// Dieser File enthaelt die Routinen fuer den BUG2 Algorithmus
#include "bug2Libaray_v3.h"








// ***************  Hauptprogramm  *************** 
int main (void)
{
   // lokale Variablen
   int   c;                                  // Tastaturabfrage Variable    
   int   k;
   int   v;
   int   i;

       
   // System initialisieren
   init_hindernis();                         // Hindernisse in der Umgebugs - Matric einfgen und zeichnen 
  
   X = Start_X;
   Y = Start_Y;
  
	
	v = 1;   
   /* ************** Endlos-Schleife ******************* */
   while ( v == 1)
   {
      
          
      
           
// ********** Nur im Learning Mode aktiv ***********            
   
Coursor_Zeichnen (X , Y);
Check_For_Hindernis (); 

gotoxy (46, 19);
printf ("                                            ");
gotoxy (46, 19);
printf ("X=%d  Y=%d  mv_dir=%d  last=%d", X, Y, move_dir, last_dir);                   
// ********** Nur im Learning Mode aktiv *********** 
      
      
      
      
      
      
      k = kbhit ();       				    	   // Borland ISR fr Tastaturpufferabfrage
      Sleep (100);
	                           
      if (k != 0)			// **** IF 1 ****       Tastaturpuffer gedrckt  > 0  = true
	   {
	      c = getch ();					         // Wert aus Tastaturpuffer lesen			


	      
         if (c == 27)                        // ESC Taste -> Program Ende 
            v = 0;
    
         if (c == 77)                   // 77 Pfeil rechts
         {
            last_dir = move_dir;
            move_dir = FWD;
            X++;
            // bug2_algo (X, Y, Ziel_X, Ziel_Y);
         } 
	      if (c == 75)                   // 75 Pfeil links
         {
            last_dir = move_dir;
            move_dir = BWD;
	         X--;
           // bug2_algo (X, Y, Ziel_X, Ziel_Y);
	      } 
	      if (c == 80)                   // 80 Pfeil unten
	      {    
   	      last_dir = move_dir;  
   	      move_dir = RIGHT;     
   	      Y++;
           // bug2_algo (X, Y, Ziel_X, Ziel_Y);

	      }
         if (c == 72)                   // 72 Pfeil oben
         { 
            last_dir = move_dir;
            move_dir = LEFT;
            Y--;
           // bug2_algo (X, Y, Ziel_X, Ziel_Y);
	        
	      }


         if (c == 13)   // **** IF 2 **** 
         {

            Check_For_Hindernis ();    // Sensoren ueberprfen ++++++++++++++++++
                                       // Ergebnis Sensor links, rechts und mitte  TRUE oder FALSE
            Coursor_Zeichnen (X , Y);
            
            if ((sensor_mitte == TRUE) && (move_dir))
            {
               bug2_algo (X, Y, Ziel_X, Ziel_Y);   // BUG2 Algorithmus aufrufen
               move_dir = 3;
            }
            
            else if ((X == Ziel_X) && (Y == Ziel_Y))
            {
               v = 0;
               gotoxy (2,yh+5);
               printf ("\n F E R T I G"); 
            }
            else
            {
               X++;                    // Auf dem Weg weiter gerade aus Richtung Ziel 
               move_dir = 3;
            }
            Coursor_Zeichnen (X , Y);
            
         }    // Ende IF 2
         
      }   // Ende IF 1

	      
   }  // Ende  While  Schleife   
   return (0);
}
